/*
** Graph.h
** 
** Made by Johnny Q. Hacker
** Login   <solarion@johnathan>
** 

Copyright (C) 2008 Joseph Pingenot

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

** Started on  Thu Jul 17 10:51:32 2008 Johnny Q. Hacker
** Last update Thu Jul 17 10:51:32 2008 Johnny Q. Hacker
*/

#ifndef   	GRAPH_H_
# define   	GRAPH_H_

#include <glib-2.0/glib-object.h>

enum graph_symbol {
     SQUARE,
     CIRCLE,
     STAR,
     PLUS,
     MINUX,
     CROSS
   };

typedef struct _Graph {
  GObject parent;
  /*Array of n_points sets of x,y coords*/
  GPtrArray *points;
  double maxx;
  double minx;
  double maxy;
  double miny;
  graph_symbol symbol;
} Graph;

typedef struct _GraphClass {
  GObject parent;
} GraphClass;

#define GRAPH_TYPE (graph_get_type())
#define GRAPH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRAPH_TYPE, Graph))
#define GRAPH_CLASS(obj) (G_TYPE_CHECK_CLASS_CAST ((obj), GRAPH, GraphClass))
#define IS_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRAPH_TYPE))
#define IS_GRAPH_CLASS(obj) (G_TYPE_CHECK_CLASS_TYPE ((obj), GRAPH_CLASS_TYPE))
#define GRAPH_GET_CLASS (G_TYPE_INSTANCE_GET_CLASS ((obj), GRAPH, GraphClass))

Graph *graph_new(void);
int graph_add_point(Graph* graph, double x, double y);

#endif 	    /* !GRAPH_H_ */
