/*
** Graph.h
** 
** Made by Johnny Q. Hacker
** Login   <solarion@johnathan>
** 

Copyright (C) 2008 Joseph Pingenot

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

** Started on  Thu Jul 17 10:51:32 2008 Johnny Q. Hacker
** Last update Thu Jul 17 10:51:32 2008 Johnny Q. Hacker
*/

#ifndef   	GRAPH_H_
# define   	GRAPH_H_

#include <gtk/gtkdrawingarea.h>
#include <graph.h>

typedef struct _GraphWidget {
  GtkDrawingArea parent;
  Graph *graph;
} GraphWidget;

typedef struct _GraphWidgetClass {
  GtkDrawingAreaClass parent_class;
  
} GraphWidgetClass;

#define GRAPH_WIDGET_TYPE (graph_widget_get_type())
#define GRAPH_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRAPH_WIDGET_TYPE, GraphWidget))
#define GRAPH_WIDGET_CLASS(obj) (G_TYPE_CHECK_CLASS_CAST ((obj), GRAPH_WIDGET, GraphWidgetClass))
#define IS_GRAPH_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRAPH_WIDGET_TYPE))
#define IS_GRAPH_WIDGET_CLASS(obj) (G_TYPE_CHECK_CLASS_TYPE ((obj), GRAPH_WIDGET_CLASS_TYPE))
#define GRAPH_WIDGET_GET_CLASS (G_TYPE_INSTANCE_GET_CLASS ((obj), GRAPH_WIDGET, GraphWidgetClass))

GtkWidget* graph_widget_new(Graph* graph);

Graph* get_graph(GraphWidget* gw);

#endif 	    /* !GRAPH_H_ */
